unit Main;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, StdCtrls, Menus, PNCAToolbar, PNCACommon, pngimage, ExtCtrls, ImgList,
  System.Actions, Vcl.ActnList;

type
  TfrmMain = class(TForm)
    pumMainMenu: TPopupMenu;
    miNew: TMenuItem;
    miOpen: TMenuItem;
    miSave: TMenuItem;
    miSaveAs: TMenuItem;
    miN1: TMenuItem;
    miExit: TMenuItem;
    lbInfo: TLabel;
    pncaToolbar: TPNCAToolbar;
    imgBtnHover: TImage;
    ilButtons: TImageList;
    alMain: TActionList;
    acNew: TAction;
    acOpen: TAction;
    acSave: TAction;
    acHelp: TAction;
    acExit: TAction;
    acSaveAs: TAction;
    procedure pncaToolbarDrawButton(Sender: TObject; AButton: TPNCAButton; const TargetCanvas: TCanvas; BtnRect, BarRect: TRect);
    procedure pncaToolbarBeforeDrawButton(Sender: TObject; AButton: TPNCAButton; const TargetCanvas: TCanvas; BtnRect,
      BarRect: TRect; var DefaultDrawing: TPNCADefaultDrawingKind);
    procedure acExitExecute(Sender: TObject);
    procedure acNewExecute(Sender: TObject);
  private
    { Private declarations }
  public
    { Public declarations }
  end;

var
  frmMain: TfrmMain;

implementation

uses
  PNCAUtils;

{$R *.dfm}

procedure TfrmMain.acExitExecute(Sender: TObject);
begin
  Close;
end;

procedure TfrmMain.acNewExecute(Sender: TObject);
begin
 ShowMessage('Button "'+TAction(Sender).Caption+'" has been clicked!');
end;

procedure TfrmMain.pncaToolbarBeforeDrawButton(Sender: TObject; AButton: TPNCAButton; const TargetCanvas: TCanvas; BtnRect,
  BarRect: TRect; var DefaultDrawing: TPNCADefaultDrawingKind);
begin
  if (AButton=TPNCAToolbar(Sender).Hovered) and AButton.HasImage and (AButton<>TPNCAToolbar(Sender).FirstButton) then
    DrawThemedImage(imgBtnHover.Picture.Graphic,TargetCanvas,BtnRect.Left,BtnRect.Top-3);
end;

procedure TfrmMain.pncaToolbarDrawButton(Sender: TObject; AButton: TPNCAButton; const TargetCanvas: TCanvas; BtnRect, BarRect: TRect);
const
  mFlags = DT_SINGLELINE or DT_CENTER or DT_VCENTER or DT_END_ELLIPSIS;
begin
  if AButton=TPNCAToolbar(Sender).FirstButton then
  begin
    // draw the text of a first toolbar's button (application's button)
    Dec(BtnRect.Right,14); Dec(BtnRect.Bottom,4); // slightly modify the text position according to currently used button image
    TargetCanvas.Font.Color := clWhite;
    if TPNCAToolbar(Sender).CompositedDrawing then
      DrawTextOnGlass(TargetCanvas, AButton.Caption, BtnRect, mFlags, TargetCanvas.Font.Color, 24)
    else
      DrawText(TargetCanvas.Handle, PChar(AButton.Caption), Length(AButton.Caption), BtnRect, mFlags);
  end;
end;

end.
